unit HoughMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
    procedure changeTo2DDataArray;
    procedure HoughLine;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  RMAX = 60;
  THETA_MAX = 1024;
  RHO_MAX = 400;
  PIK  = PI / THETA_MAX;
  XMAX = 320;
  YMAX = 240;
  IWIDTH = XMAX * 2;
  IHEIGHT = YMAX;
  RBAND = 5;

var
  sn : array[0..THETA_MAX - 1] of double;
  cs : array[0..THETA_MAX - 1] of double;
  diagonal : array[0..YMAX - 1,0..XMAX - 1] of short;
  data: array[0..YMAX - 1] of array[0..XMAX - 1] of byte;
  counter : array[0..THETA_MAX - 1] of array[0..RHO_MAX + RHO_MAX -1] of short;
  counter1 : array[0..YMAX - 1] of array[0..XMAX - 1] of array[0..RMAX - 1] of short;

  Image: Tbitmap;

// t@C摜f[^[[h (24rbgJ[)
// bNAbve[u
procedure TForm1.Button1Click(Sender: TObject);
var
  i, x, y : integer;
begin
  Image.LoadFromFile('sample1.bmp');
  changeTo2DDataArray;
  Image1.Canvas.Draw(0, 0, Image);
  // Ope[u쐬@TC RTC p
  for i := 0 to THETA_MAX - 1 do begin
    sn[i] := sin(PIK * i);
    cs[i] := cos(PIK * i);
  end;
  // ΐe[u쐬 ~p
  for y := 0 to YMAX - 1 do begin
    for x := 0 to XMAX - 1 do begin
      diagonal[y, x] := round(sqrt(y * y + x * x));
    end;
  end;
  button2.Enabled := True;
end;

// ntϊ
procedure TForm1.HoughLine;
var
  theta, rho  : integer;
  x, y: integer;
  centerX, centerY, distX, distY, radius: integer;
  end_flag : integer;  // JԂItO
  count    : integer;  // oꂽ͉~̌JEg
  counter_max : integer;
  theta_maxs : integer;
  rho_maxm   : integer;
  thetay: Integer;
  j, i  : Integer;
  counter1_max : integer;
  centerX_max : integer;
  centerY_max : integer;
  radius_max  : integer;
  k: Integer;
begin
// ̏ꍇ
  for y :=0 to YMAX - 1 do begin
    for x := 0 to XMAX - 1 do begin
      if data[y, x] = 1 then begin
        for theta := 0 to THETA_MAX - 1 do begin
          rho := round(x * cs[theta] + y * sn[theta]);
//          form1.Canvas.TextOut(0,0,inttostr(rho));
          inc(counter[theta, rho + RHO_MAX]);
        end;
      end;
    end;
  end;
// ~̏ꍇ
  for y := 0 to YMAX - 1 do
    for x := 0 to XMAX - 1 do
      if data[y, x] = 1 then
        for centerY := 0 to YMAX - 1 do begin
          distY := abs(y - centerY);
          if distY <= RMAX then
            for centerX := 0 to XMAX - 1 do begin
              distX := abs(x - centerX);
              radius := diagonal[distY, distX];
              if radius < RMAX then
                inc(counter1[centerY, centerX, radius])
            end;
        end;
// --------------------- Houghtϊ -------------------------
  // 摜f[^[Eɕ`悷
  for y := 0 to YMAX - 1 do
    for x := 0 to XMAX - 1 do
      if data[y, x] = 1 then image1.Canvas.Pixels[x + XMAX, y] := clGray;
  // ̏ꍇ ------------------
  theta_maxs := 0;
  rho_maxm := - RHO_MAX;
  end_flag := 0;
  count := 0;
  // 60sNZȉA10{ɂȂ܂Ōo
  while (end_flag = 0) and (count < 10) do begin
    inc(count);
    counter_max := 0;
    // counter őɂȂtheta_maxrho_max ߂B
    for thetay := 0 to THETA_MAX - 1 do
      for rho := -RHO_MAX to RHO_MAX - 1 do
        if counter[thetay, rho + RHO_MAX] > counter_max then begin
          counter_max := counter[thetay, rho + RHO_MAX];
          // 60sNZȉ̒ɂȂΌoI
          if counter_max <= 60 then end_flag := 1
                               else end_flag := 0;
          theta_maxs := thetay;
          rho_maxm := rho;
        end;
    // o̕`
    // xωy`i̐j
    if theta_maxs <> 0 then begin
      for x := 0 to XMAX - 1 do begin
        y := round((rho_maxm - x * cs[theta_maxs]) / sn[theta_maxs]);
        if (y < YMAX) and (y >= 0) then
          image1.Canvas.Pixels[x + XMAX, y] := clRed;
      end;
    end;
    // yωx`(̐)
    if theta_maxs <> THETA_MAX div 2 then
      for y := 0 to YMAX - 1 do begin
        x := round((rho_maxm - y * sn[theta_maxs]) / cs[theta_maxs]);
        if (x < XMAX) and (x >= 0) then
          image1.Canvas.Pixels[x + XMAX, y] := clRed;
      end;
    // ߖT̒
    for j := -10 to 10 do
      for i := -30 to 30 do begin
        if theta_maxs + i < 0 then begin
          theta_maxs := theta_maxs + THETA_MAX;
          rho_maxm := - rho_maxm;
        end;
        if theta_maxs + i >= THETA_MAX then begin
          theta_maxs := theta_maxs - THETA_MAX;
          rho_maxm := - rho_maxm;
        end;
        if (rho_maxm + J >= -RHO_MAX) and (rho_maxm + J <= RHO_MAX) then
          counter[theta_maxs + i, rho_maxm + RHO_MAX + j] := 0;
      end;
  end;
  // ~̏ꍇ -------------------------
  centerX_max := 0;
  centerY_max := 0;
  radius_max  := 0;
  end_flag := 0;
  count := 0;
  image1.Canvas.Pen.Color := clFuchsia;
  image1.Canvas.Pen.Width := 1;
  image1.Canvas.Brush.Style := bsClear;
  // 傫150sNZȉA܌ɂȂ܂Ōo
  while (end_flag = 0) and (count < 5) do begin
    inc(count);
    counter1_max := 0;
    // counter1őɂȂcenterX_maxA
    // centerY_maxradius_max߂
    for centerY := 0 to YMAX - 1 do
      for centerX := 0 to XMAX - 1 do
        for radius := 0 to RMAX - 1 do
          if counter1[centerY, centerX, radius] > counter1_max then begin
            counter1_max := counter1[centerY, centerX, radius];
            // 150sNZȉ̉~ɂȂΌoI
            if counter1_max <= 150 then end_flag := 1
                                   else end_flag := 0;
            centerY_max := centerY;
            centerX_max := centerX;
            radius_max := radius;
          end;
    // ߖT̉~
    for k := -RBAND to RBAND do
      if (centerY_max + k < YMAX) and (centerY_max + k >= 0) then
        for j := -RBAND to RBAND do
          if (centerX_max + j < XMAX) and (centerX_max + j >= 0) then
            for i := -RBAND to RBAND do
              if (radius_max + i < RMAX) and (radius_max + i >= 0) then
                counter1[centerY_max + k, centerX_max + j, radius_max + i] := 0;
    // o~̕`
    image1.Canvas.Ellipse(XMAX + centerX_max - radius_max,
                          centerY_max - radius_max,
                          XMAX + centerX_max + radius_max + 1,
                          centerY_max + radius_max + 1);
  end;
end;

// ntϊ
procedure TForm1.Button2Click(Sender: TObject);
var
  i, x, y: integer;
begin
  // pJE^[zNA
  for i := 0 to THETA_MAX - 1 do
    for x := 0 to 2 * RHO_MAX -1 do begin
      counter[i, x] := 0;
    end;
  // ~pJE^[ zNA
  for y := 0 to YMAX - 1 do
    for x := 0 to XMAX - 1 do
      for i := 0 to RMAX - 1 do
        counter1[y, x, i] := 0;
  // ntϊ
  HoughLine;
end;

// ntϊp񎟌f[^[  2l
// PƂAȊO͂OƂ܂B
procedure TForm1.changeTo2DDataArray;
var
  width:  integer;
  height: integer;
  r, g, b : byte;
  i, j, k: integer;
  PD : PByteArray;
begin
  width := Image.Width;
  Height := Image.Height;

  for i := 0 to Height - 1 do begin
    PD := Image.ScanLine[i];
    for j := 0 to width - 1 do
      begin
        k := j * 3;
        b := PD[k];
        g := PD[k + 1];
        r := PD[k + 2];
        if b + g + r = 0 then data[i, j] := 1
                         else data[i, j] := 0;
      end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Image1.Width := IWIDTH;
  Image1.Height := IHEIGHT;
  Image := TBitmap.Create;
  button2.Enabled := false;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Image.Free;
end;

end.
